<?PHP

require_once('modules/PX_FlowchartTemplates/PX_FlowchartTemplates_sugar.php');

class PX_FlowchartTemplates extends PX_FlowchartTemplates_sugar
{
    public const DEFAULT_ENGINE_TYPE = 'base';

    public function __construct()
    {
        parent::__construct();
    }

    function save($check_notify = false)
    {
        if (base64_encode(base64_decode($this->html_body)) !== $this->html_body) {
            $this->html_body = base64_encode($this->html_body);
        }
        if (base64_encode(base64_decode($this->context)) !== $this->context) {
            $this->context = base64_encode($this->context);
        }
        if (empty($this->tpl_engine_type)) {
            $this->tpl_engine_type = self::DEFAULT_ENGINE_TYPE;
        }
        $id = parent::save($check_notify);
        return $id;
    }

    public function getDecodedContext($context)
    {
        if (!empty($context)) {
            $base64DecodedContext = base64_decode($context);
            if (!$base64DecodedContext || base64_encode($base64DecodedContext) !== $context) {
                $base64DecodedContext = $context;
            }
            if ($base64DecodedContext) {
                json_decode($base64DecodedContext, true);
                if (json_last_error() === JSON_ERROR_NONE) {
                    return $base64DecodedContext;
                }
            }
            return 'error';
        }
        return '';
    }

    public function getContext()
    {
        $context = [];
        if (!empty($this->context) && is_string($this->context)) {
            $context = json_decode(htmlspecialchars_decode($this->context), true);
        }
        return json_last_error() == JSON_ERROR_NONE ? $context : [];
    }

    public function getHtmlBody()
    {
        if (!empty($this->html_body)) {
            return str_replace(array('%7B', '%7D'), array('{', '}'), $this->html_body);
        }
        return '';
    }

    public function decodeHtmlBody($htmlBody)
    {
        if (!empty($htmlBody) && base64_encode(base64_decode($htmlBody)) === $htmlBody) {
            return base64_decode($htmlBody);
        }
        return $htmlBody;
    }

}